#include <iostream>

using namespace std;

int main()
{
    int w,h,r,q;
    cin>>w>>h>>r>>q;
    int A[q];
    int B[q];
    double H[q];
    for(int i=0;i<q;i++)
        H[i]=h;
    for(int i=0;i<q;i++){
        int k;
        cin>>k;
        if(k==1){
            int a,b;
            cin>>a>>b;
            A[i]=a;
            B[i]=b;
            if(b==h){
                H[a]=b-1;
                if(H[a]>h)
                    H[a]=h;
            }
        }
        if(k==2){
            int a;
            cin>>a;
            A[i]=a;
            B[i]=-69;
        }
    }
    for(int i=0;i<q;i++){
        if(B[i]==-69){
            int x=A[i];
            cout<<H[x]<<endl;
        }
    }
    return 0;
}